#ifndef __UCLIB_H__
#define __UCLIB_H__
#define	RAND_MAX	2147483647

//extern "C"
//{
//	
//	unsigned int alloc(unsigned int nbytes);
//	unsigned int Drv_realloc(unsigned int address,unsigned int nbytes);
//	void deAlloc(unsigned int address);
//  unsigned int Drv_calloc(unsigned int size,unsigned int n);
//}


#include <stdlib.h>

#include <sys/types.h> /* size_t */
#include <linux/errno.h>
#include <sys/unistd.h>
#include <stdarg.h>
#include <stdint.h>
#include <stddef.h>
#include <assert.h>
#include <limits.h>
#include "jz_mxu.h"

//typedef struct
//{
//  int quot;			// Quotient.  
//  int rem;			// Remainder.  
//} div_t;
//
#undef div
  
#define div(a, b)                       \
({                                      \
  div_t result;                         \
  result.quot = a / b;                  \
  result.rem = a - (result.quot * b);   \
  result;                               \
})

#define off_t int 

#define abs(a)	   (((a) < 0) ? -(a) : (a))
#undef malloc

//#define MEMDEBUG 1
#ifdef MEMDEBUG
#define malloc(x) ({void * mem;printf("malloc:%s %d",__FILE__,__LINE__);mem = uc_malloc(x);printf(" addr = %08x len = %d\n",mem,x);mem;})
#else
#define malloc(x) uc_malloc(x)
#endif

#undef free

#ifdef MEMDEBUG
#define free(x) ({printf("free:%s %d addr = %08x\n",__FILE__,__LINE__,x);uc_free(x);})
#else
#define free(x) uc_free(x)
#endif

#undef callloc

#ifdef MEMDEBUG
#define calloc(x,y) ({void *mem;printf("calloc:%s %d",__FILE__,__LINE__);mem = uc_calloc(x,y);printf(" addr = %08x len = %d\n",mem,x,y);mem;})
#else
#define calloc(x,y) uc_calloc(x,y)
#endif

#undef realloc
#ifdef MEMDEBUG
#define realloc(x,y) ({void *mem;printf("realloc:%s %d",__FILE__,__LINE__);mem = uc_realloc(x,y);printf(" addr = %08x %d\n",mem,y);mem;})
#else
#define realloc(x,y) uc_realloc(x,y)
#endif

#undef memalign

#ifdef MEMDEBUG
 #define memalign(x,y) ({void *mem;printf("memalign:%s %d",__FILE__,__LINE__); mem = uc_memalign(x,y);printf(" addr = %08x %d\n",mem,y);mem;})
#else
 #define memalign(x,y) uc_memalign(x,y)
#endif
#undef strdup

#ifdef MEMDEBUG
#define strdup(x) ({char * mem;printf("strdup:%s %d",__FILE__,__LINE__);mem = uc_strdup(x);printf(" addr = %08x\n",mem);mem;})
#else
#define strdup(x) uc_strdup(x)
#endif

//#define LocalAlloc(x,size) (void *)alloc(size)
//#define LocalFree(x) deAlloc(()unsigned int)x)
/*
inline void *uc_malloc(unsigned int addr);
inline void uc_free(void *addr);
inline void *uc_calloc(unsigned int x,unsigned int n);
inline void *uc_realloc(void *addr,unsigned int size);
inline void *uc_memalign(unsigned int x,unsigned int size);
char * uc_strdup(const char *str);
*/

inline static void *uc_malloc(unsigned int addr)
{
	return (void *)alloc((unsigned int)addr);	;
}
inline static void uc_free(void *addr)
{
	if(addr != NULL)
		deAlloc((unsigned int)addr);
}
inline static void *uc_calloc(unsigned int x,unsigned int n)
{
	return (void *)Drv_calloc(x,n);
}
inline static void *uc_realloc(void *addr,unsigned int size)
{
	return Drv_realloc((unsigned int)addr,(unsigned int)size);
}
inline static char * uc_strdup(const char *str)
{
   char *p;
   if (!str)
      return(NULL);
   if (p = uc_malloc(strlen(str) + 1))
      return(strcpy(p,str));
   return(NULL);
}
inline static void *uc_memalign(unsigned int x,unsigned int size)
{
	return (void *)alignAlloc(x,(unsigned int)size);
}

#define F(x,s...) {printf("%s:%d  ",__FILE__,__LINE__); printf(x,##s);}
#undef stderr
#define stderr 1
#undef stdout
#define stdout 2
#undef fprintf
#define fprintf(x,y,c...) ({printf("%s %d",__FILE__,__LINE__); printf(y,##c);})

#undef vfprintf
#define vfprintf fprintf

#define MY_THROW() asm("syscall")
#undef exit
#define exit(x) do{ printf("=======================%s %d exit\n",__FILE__,__LINE__); return x;}while(0)
#undef perror
#define perror printf
#undef fflush
#define fflush(x) 

/*
inline void * mxu_memset_32 (void *BLOCK, int C) {
  int32_t tmp; 
  S32I2M(xr1, C);
  tmp = (int32_t)BLOCK - 4;
  S32SDI(xr1, tmp, 4);
  S32SDI(xr1, tmp, 4);
  S32SDI(xr1, tmp, 4);
  S32SDI(xr1, tmp, 4);
  S32SDI(xr1, tmp, 4);
  S32SDI(xr1, tmp, 4);
  S32SDI(xr1, tmp, 4);
  S32SDI(xr1, tmp, 4);
}
*/

inline static void *uc_memcpy_tmp(void *to,const void *from,unsigned int size)
{
	memcpy(to,from,size);
}
void *uc_memcpy(void *to,const void *from,unsigned int size);

#undef memcpy
#define memcpy(x,y,z) uc_memcpy(x,y,z)

#undef memove
#define memove(x,y,z) uc_memcpy(x,y,z)
#endif

#define ShowAddress()          \
do                             \
{			unsigned int dra;        \
			__asm__ __volatile__(    \
			"sw $31,0x00(%0)\n\t"    \
            :                  \
			: "r" (&dra));           \
		F("%x\n",dra);             \
}while(0)